<template>
  <el-link
    v-if="site==='operation'&&show"
    style="padding: 0 10px"
    :icon="myIcon"
    :loading="loading"
    :plain="myPlain"
    :size="mySize"
    :type="myType"
    @click="click"
  >{{ myName }}
  </el-link>
  <el-button
    v-else-if="show"
    :icon="myIcon"
    :loading="loading"
    :plain="myPlain"
    :size="mySize"
    :type="myType"
    @click="click"
  >{{ myName }}
  </el-button>
</template>
<script>
export default {
  name: 'MyButtonV2',
  props: {
    checkPermission: { // 按钮权限
      type: String,
      default: ''
    },
    site: { // filter 搜索条，tools 工具条，operation 操作栏，form 表单
      type: String,
      default: ''
    },
    type: {// 按钮类型
      type: String,
      default: ''
    },
    name: {// 按钮名称
      type: String,
      default: ''
    },
    icons: {// 图标
      type: String,
      default: null
    }
  },
  data() {
    return {
      filter: {// 搜索条上的按钮名称集合
        size: 'small',
        plain: false,
        other: {
          '搜索': {
            type: 'primary',
            icon: 'el-icon-search'
          },
          '重置': {
            type: '',
            icon: 'el-icon-refresh'
          },
          '完结': {
            type: 'warning',
            icon: 'el-icon-warning-outline'
          },
          '进入系统': {
            type: '',
            icon: 'el-icon-login'
          }
        }
      },
      tools: {// 工具条上的按钮集合
        size: 'mini',
        plain: false,
        type: 'default',
        other: {
          '添加': {
            icon: 'el-icon-edit-outline'
          },
          '批量删除': {
            icon: 'el-icon-delete'
          },
          '批量启用': {
            icon: 'el-icon-refresh'
          },
          '导入': {
            icon: 'el-icon-upload2'
          },
          '导入模板下载': {
            icon: 'el-icon-download'
          },
          '批量导入': {
            icon: 'el-icon-upload2'
          },
          '导出': {
            icon: 'el-icon-download'
          },
          '批量下架': {
            icon: 'el-icon-edit-outline'
          },
          '批量延期': {
            icon: 'el-icon-date'
          },
          '查重': {
            icon: 'el-icon-s-help'
          },
          '打印': {
            icon: 'el-icon-printer'
          },
          '导出EXCEL': {
            icon: 'el-icon-download'
          },
          '导出EXCEL(不分页)': {
            icon: 'el-icon-download'
          },
          '导出EXCEL(分页)': {
            icon: 'el-icon-download'
          },
          '导出WORD': {
            icon: 'el-icon-download'
          },
          '导出PDF': {
            icon: 'el-icon-download'
          }
        }
      },
      operation: {// 操作栏上的按钮集合
        size: 'mini',
        plain: true,
        other: {
          '编辑': {
            type: 'success'
          },
          '处理': {
            type: 'primary'
          },
          '审批': {
            type: 'success'
          },
          '事务反馈': {
            type: 'primary'
          },
          '发布': {
            type: 'primary'
          },
          '删除': {
            type: 'primary'
          },
          '权限': {
            type: 'warning'
          },
          '角色': {
            type: 'info'
          },
          '重置密码': {
            type: 'warning'
          },
          '组织架构': {
            type: 'danger'
          },
          '人员': {
            type: 'success'
          },
          '上架': {
            type: 'success'
          },
          '下架': {
            type: 'danger'
          },
          '延期': {
            type: 'warning'
          },
          '备件需求': {
            type: 'warning'
          },
          '维修/改造': {
            type: 'success'
          },
          '备注': {
            type: 'warning'
          },
          '沟通记录': {
            type: 'success'
          },
          '查看备注': {
            type: 'info'
          },
          '查看沟通记录': {
            type: 'success'
          },
          '启用': {
            type: 'success'
          },
          '禁用': {
            type: 'warning'
          },
          '启用黑名单': {
            type: 'success'
          },
          '加入黑名单': {
            type: 'danger'
          },
          '授权用户': {
            type: 'danger'
          },
          '查看': {
            type: 'success'
          },
          '查看详情': {
            type: 'info'
          },
          '记录': {
            type: 'primary'
          },
          '设置利润率': {
            type: 'success'
          },
          '审核': {
            type: 'success'
          },
          '采购': {
            type: 'success'
          },
          '质检确认': {
            type: 'success'
          },
          '关联客户经理': {
            type: 'primary'
          },
          '处理确认': {
            type: 'primary'
          },
          '详情': {
            type: 'success'
          },
          '委外加工': {
            type: 'primary'
          },
          '制造进度': {
            type: 'warning'
          },
          '入库确认': {
            type: 'warning'
          },
          '定价': {
            type: 'danger'
          },
          '虚拟入库': {
            type: 'primary'
          },
          '受理审核': {
            type: 'primary'
          },
          '查看记录': {
            type: 'info'
          },
          '关联该商品': {
            type: 'info'
          },
          '议价处理': {
            type: 'warning'
          },
          '分期审批': {
            type: 'success'
          },
          '签合同': {
            type: 'success'
          },
          '设计': {
            type: 'primary'
          },
          '测量': {
            type: 'success'
          },
          '开票': {
            type: 'success'
          },
          '受理确认': {
            type: 'success'
          },
          '售后处理': {
            type: 'success'
          },
          '确认支付': {
            type: 'warning'
          },
          '上传发票': {
            type: 'primary'
          },
          '确认收款': {
            type: 'warning'
          },
          '收款详细': {
            type: 'success'
          },
          '预览': {
            type: 'warning'
          }
        }
      },
      form: { // 表单上的按钮
        size: 'small',
        plain: false,
        other: {
          '提交': {
            type: 'primary'
          },
          '发布': {
            type: 'primary'
          },
          '关闭': {
            type: 'default'
          },
          '保存': {
            type: 'primary'
          },
          '取消': {
            type: 'default'
          },
          '重置': {
            type: 'default'
          },
          '暂存': {
            type: 'warning'
          },
          '查询': {
            type: 'primary'
          },
          '关联该用户': {
            type: 'success'
          },
          '确认': {
            type: 'primary'
          },
          '确定': {
            type: 'primary'
          },
          '报价': {
            type: 'success'
          },
          '下一步': {
            type: 'primary'
          },
          '上一步': {
            type: 'default'
          },
          '选择': {
            type: 'primary'
          },
          '驳回': {
            type: 'primary'
          },
          '通过': {
            type: 'success'
          }
        }
      },
      text: { // 表单上的按钮
        size: 'mini',
        type: 'text',
        icon: '',
        other: {
          '添加': {
            icon: 'el-icon-circle-plus-outline'
          }
        }
      },
      loading: false,
      myType: this.type, // 按钮类型
      myName: this.name, // 按钮名称
      myIcon: this.icon, // 按钮图标
      mySize: this.size, // 按钮大小
      myPlain: this.plain, // 是否朴素按钮
      show: true // 是否显示
    }
  },
  created() {
    // console.log(this.$store.getters.permissions);
    if (this.checkPermission != '') {
      let userPermission = this.$store.getters.permissions;
      if(userPermission.indexOf("*:*:*") >= 0){
        // 有所有权限
        this.show = true;
      } else if(userPermission.indexOf(this.checkPermission) < 0){
        this.show = false
        return
      }
    }
    this.myName = this.name
    if (this.site == 'filter') {
      this.mySize = this.filter.size
      this.myPlain = this.filter.plain
      this.myType = (this && this.type) || this.filter.other[this.myName].type
      this.myIcon = this.filter.other[this.myName].icon
    } else if (this.site == 'tools') {
      this.mySize = this.tools.size
      this.myPlain = this.tools.plain
      this.myType = (this && this.type) || this.tools.type
      if (this.icons != null) {
        this.myIcon = this.icons
      } else {
        this.myIcon = this.tools.other[this.myName].icon
      }
    } else if (this.site == 'operation') {
      this.mySize = this.operation.size
      this.myPlain = this.operation.plain
      this.myType = this.type || (this.operation.other[this.myName] ? this.operation.other[this.myName].type : '')
    } else if (this.site == 'form') {
      this.mySize = this.form.size
      this.myPlain = this.form.plain
      this.myType = (this && this.type) || this.form.other[this.myName].type
    } else if (this.site == 'text') {
      this.mySize = this.text.size
      this.myType = (this && this.type) || this.text.type
      this.myIcon = this.text.other[this.myName].icon
    } else {
      this.mySize = 'mini'
      this.myPlain = false
      this.myType = 'text'
    }
  },
  methods: {
    click() {
      if (this.site == 'form') {
        this.loading = true
      }
      this.$emit('click')
      setTimeout(() => {
        this.loading = false
      }, 1500)// 1.5秒内不能重复点击
    }
  }
}
</script>
